 
create table TFSFisNFPrMW
(
    CodigoEmp           char(2)        not null,
    CodigoUnidade       char(8)        not null,
    TipoNota            char(1)        not null,
    ModeloNota          char(2)        not null,
    CodParticipante     char(14)       not null,
    Numero              char(9)        not null,
    Serie               char(3)        not null,
    Status              char(2)        not null,
    CodNFSE             char(60)       not null,
    DataEmissao         char(8)        not null, 
    DataEntSai          char(8)        not null, 
    ValorTotal          dec(17,2)      not null,
    ValorTotalDesc      dec(17,2)      not null,
    ValorAbatNTrib      dec(17,2)      not null,
    ValorTotalMerc      dec(17,2)      not null,
    ValorTotalFrete     dec(17,2)      not null,
    ValorTotalSeg       dec(17,2)      not null,
    ValorTotalDesp      dec(17,2)      not null,
    BaseCalcICMS        dec(17,2)      not null,
    ValorTotICMS        dec(17,2)      not null,
    BaseCalcICMSST      dec(17,2)      not null,
    ValorTotICMSST      dec(17,2)      not null,
    ValorTotIPI         dec(17,2)      not null,
    ValorTotPIS         dec(17,2)      not null,
    ValorTotPISST       dec(17,2)      not null,
    ValorTotCOFINS      dec(17,2)      not null,
    ValorTotCOFINSST    dec(17,2)      not null,
    TipoPagamento       char(1)        not null,
    TipoFrete           char(1)        not null,
    PropriaTerceiro     char(1)        not null
);

Insert into TFSFisNFPrMW Select CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero,
                                Serie, Status, CodNFSE, DataEmissao, DataEntSai, ValorTotal, ValorTotalDesc, 
                                ValorAbatNTrib, ValorTotalMerc, ValorTotalFrete, ValorTotalSeg, ValorTotalDesp,
                                BaseCalcICMS, ValorTotICMS, BaseCalcICMSST, ValorTotICMSST, ValorTotIPI,
                                ValorTotPIS, ValorTotPISST, ValorTotCOFINS, ValorTotCOFINSST,
                                TipoPagamento, TipoFrete, 'T' From TFSFisNFPrM where TipoNota = 'E';

Insert into TFSFisNFPrMW Select CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero,
                                Serie, Status, CodNFSE, DataEmissao, DataEntSai, ValorTotal, ValorTotalDesc, 
                                ValorAbatNTrib, ValorTotalMerc, ValorTotalFrete, ValorTotalSeg, ValorTotalDesp,
                                BaseCalcICMS, ValorTotICMS, BaseCalcICMSST, ValorTotICMSST, ValorTotIPI,
                                ValorTotPIS, ValorTotPISST, ValorTotCOFINS, ValorTotCOFINSST,
                                TipoPagamento, TipoFrete, 'P' From TFSFisNFPrM where TipoNota = 'S';

alter table TFSFisNFPrPr drop constraint FK_TFSFisNFPrM_Prc;

alter table TFSFisNFPrIt drop constraint FK_TFSFisNFPrM_Item;

alter table TFSFisNFPrIm drop constraint FK_TFSFisNFPrM_Imp;

alter table TFSFisNFPrCm drop constraint FK_TFSFisNFPrM_Obs;

UPDATE TFSFisNFPrMW SET TIPONOTA = 'E' WHERE EXISTS (SELECT * FROM  TFSFisNFPrIt
 WHERE TFSFisNFPrMW.CodigoEmp = TFSFisNFPrIt.CodigoEmp 
  AND  TFSFisNFPrMW.CodigoUnidade = TFSFisNFPrIt.CodigoUnidade
  AND  TFSFisNFPrMW.TipoNota = TFSFisNFPrIt.TipoNota
  AND  TFSFisNFPrMW.ModeloNota = TFSFisNFPrIt.ModeloNota 
  AND  TFSFisNFPrMW.CodParticipante = TFSFisNFPrIt.CodParticipante 
  AND  TFSFisNFPrMW.Numero = TFSFisNFPrIt.Numero
  AND  TFSFisNFPrMW.Serie = TFSFisNFPrIt.Serie
  AND  SUBSTRING(TFSFisNFPrIt.CFOP,1,1) IN ('1', '2', '3'))
  AND  TFSFisNFPrMW.TipoNota = 'S';

UPDATE TFSFisNFPrPr SET TIPONOTA = 'E' WHERE EXISTS (SELECT * FROM  TFSFisNFPrIt
 WHERE TFSFisNFPrPr.CodigoEmp = TFSFisNFPrIt.CodigoEmp 
  AND  TFSFisNFPrPr.CodigoUnidade = TFSFisNFPrIt.CodigoUnidade
  AND  TFSFisNFPrPr.TipoNota = TFSFisNFPrIt.TipoNota
  AND  TFSFisNFPrPr.ModeloNota = TFSFisNFPrIt.ModeloNota 
  AND  TFSFisNFPrPr.CodParticipante = TFSFisNFPrIt.CodParticipante 
  AND  TFSFisNFPrPr.Numero = TFSFisNFPrIt.Numero
  AND  TFSFisNFPrPr.Serie = TFSFisNFPrIt.Serie
  AND  SUBSTRING(TFSFisNFPrIt.CFOP,1,1) IN ('1', '2', '3'))
  AND  TFSFisNFPrPr.TipoNota = 'S';

UPDATE TFSFisNFPrIm SET TIPONOTA = 'E' WHERE EXISTS (SELECT * FROM  TFSFisNFPrIt
 WHERE TFSFisNFPrIm.CodigoEmp = TFSFisNFPrIt.CodigoEmp 
  AND  TFSFisNFPrIm.CodigoUnidade = TFSFisNFPrIt.CodigoUnidade
  AND  TFSFisNFPrIm.TipoNota = TFSFisNFPrIt.TipoNota
  AND  TFSFisNFPrIm.ModeloNota = TFSFisNFPrIt.ModeloNota 
  AND  TFSFisNFPrIm.CodParticipante = TFSFisNFPrIt.CodParticipante 
  AND  TFSFisNFPrIm.Numero = TFSFisNFPrIt.Numero
  AND  TFSFisNFPrIm.Serie = TFSFisNFPrIt.Serie
  AND  SUBSTRING(TFSFisNFPrIt.CFOP,1,1) IN ('1', '2', '3'))
  AND  TFSFisNFPrIm.TipoNota = 'S';

UPDATE TFSFisNFPrCm SET TIPONOTA = 'E' WHERE EXISTS (SELECT * FROM  TFSFisNFPrIt
 WHERE TFSFisNFPrCm.CodigoEmp = TFSFisNFPrIt.CodigoEmp 
  AND  TFSFisNFPrCm.CodigoUnidade = TFSFisNFPrIt.CodigoUnidade
  AND  TFSFisNFPrCm.TipoNota = TFSFisNFPrIt.TipoNota
  AND  TFSFisNFPrCm.ModeloNota = TFSFisNFPrIt.ModeloNota 
  AND  TFSFisNFPrCm.CodParticipante = TFSFisNFPrIt.CodParticipante 
  AND  TFSFisNFPrCm.Numero = TFSFisNFPrIt.Numero
  AND  TFSFisNFPrCm.Serie = TFSFisNFPrIt.Serie
  AND  SUBSTRING(TFSFisNFPrIt.CFOP,1,1) IN ('1', '2', '3'))
  AND  TFSFisNFPrCm.TipoNota = 'S';

UPDATE TFSFisNFPrIt SET TIPONOTA = 'E'
 WHERE SUBSTRING(TFSFisNFPrIt.CFOP,1,1) IN ('1', '2', '3')
  AND  TFSFisNFPrIt.TipoNota = 'S';

alter table TFSFisNFPrM drop constraint PK_TFSFisNFPrM;

drop table TFSFisNFPrM; 
 
create table TFSFisNFPrM
(
    CodigoEmp           char(2)        not null,
    CodigoUnidade       char(8)        not null,
    TipoNota            char(1)        not null,
    ModeloNota          char(2)        not null,
    CodParticipante     char(14)       not null,
    Numero              char(9)        not null,
    Serie               char(3)        not null,
    Status              char(2)        not null,
    CodNFSE             char(60)       not null,
    DataEmissao         char(8)        not null, 
    DataEntSai          char(8)        not null, 
    ValorTotal          dec(17,2)      not null,
    ValorTotalDesc      dec(17,2)      not null,
    ValorAbatNTrib      dec(17,2)      not null,
    ValorTotalMerc      dec(17,2)      not null,
    ValorTotalFrete     dec(17,2)      not null,
    ValorTotalSeg       dec(17,2)      not null,
    ValorTotalDesp      dec(17,2)      not null,
    BaseCalcICMS        dec(17,2)      not null,
    ValorTotICMS        dec(17,2)      not null,
    BaseCalcICMSST      dec(17,2)      not null,
    ValorTotICMSST      dec(17,2)      not null,
    ValorTotIPI         dec(17,2)      not null,
    ValorTotPIS         dec(17,2)      not null,
    ValorTotPISST       dec(17,2)      not null,
    ValorTotCOFINS      dec(17,2)      not null,
    ValorTotCOFINSST    dec(17,2)      not null,
    TipoPagamento       char(1)        not null,
    TipoFrete           char(1)        not null,
    PropriaTerceiro     char(1)        not null
);
 
Insert into TFSFisNFPrM Select * from TFSFisNFPrMW;
 
alter table TFSFisNFPrM
    add constraint PK_TFSFisNFPrM primary key ( CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie);

alter table TFSFisNFPrIm
    add constraint FK_TFSFisNFPrM_Imp foreign key  (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie)
       references TFSFisNFPrM (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie);

alter table TFSFisNFPrPr
    add constraint FK_TFSFisNFPrM_Prc foreign key  (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie)
       references TFSFisNFPrM (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie);
 
alter table TFSFisNFPrIt
    add constraint FK_TFSFisNFPrM_Item foreign key  (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie)
       references TFSFisNFPrM (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie);

alter table TFSFisNFPrCm
    add constraint FK_TFSFisNFPrM_Obs foreign key  (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie)
       references TFSFisNFPrM (CodigoEmp, CodigoUnidade, TipoNota, ModeloNota, CodParticipante, Numero, Serie);

create index TFSFisNFPrM_FK1 on TFSFisNFPrM ( CodigoEmp, CodigoUnidade, TipoNota, DataEmissao );
create index TFSFisNFPrM_FK2 on TFSFisNFPrM ( CodigoEmp, CodigoUnidade, TipoNota, DataEntSai );
create index TFSFisNFPrM_FK3 on TFSFisNFPrM ( CodigoEmp, TipoNota, DataEmissao );
create index TFSFisNFPrM_FK4 on TFSFisNFPrM ( CodigoEmp, CodNFSE );
create index TFSFisNFPrM_FK5 on TFSFisNFPrM ( CodParticipante, TipoNota, CodigoUnidade, CodigoEmp );

GRANT ALL ON TFSFisNFPrM TO BYTEC;

DROP TABLE TFSFisNFPrMW;


